'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _rcUtil = require('rc-util');

var _rcUtil2 = _interopRequireDefault(_rcUtil);

var Steps = function Steps(_ref) {
  var className = _ref.className;
  var stepNum = _ref.stepNum;
  var included = _ref.included;
  var lowerIndex = _ref.lowerIndex;
  var upperIndex = _ref.upperIndex;

  var dotClassName = className.replace('step', 'dot');
  var unit = 100 / (stepNum - 1);

  var elements = [];
  for (var i = 0; i < stepNum; i++) {
    var _rcUtil$classSet;

    var offset = unit * i + '%';
    var style = { left: offset };

    var isActived = included && i <= upperIndex && i >= lowerIndex || !included && i === upperIndex;
    var stepClassName = _rcUtil2['default'].classSet((_rcUtil$classSet = {}, _defineProperty(_rcUtil$classSet, dotClassName, true), _defineProperty(_rcUtil$classSet, dotClassName + '-active', isActived), _rcUtil$classSet));

    elements.push(_react2['default'].createElement('span', { className: stepClassName, style: style, key: i }));
  }

  return _react2['default'].createElement(
    'div',
    { className: className },
    elements
  );
};

exports['default'] = Steps;
module.exports = exports['default'];